Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® OLAP Java API Reference 10g Release 2 (10.2) B14348-02
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.olapi.data.source
Class NumberSource

    java.lang.Object
      |
      +--oracle.olapi.data.source.Source
            |
            +--oracle.olapi.data.source.NumberSource

public final class NumberSource
extends Source

A `Source` whose elements have numeric values, which are `double`, `float`, `int`, or `short` values, or some combination of those values. Depending on the data type of its values, a `NumberSource` has an OLAP API data type of Double, Float, Integer, Short, or Number.

The `NumberSource` class implements the following types of methods:

- Some `Source` methods so that they use numeric values, such as `appendValue`.
- Methods that perform numeric operations, such as `div`, `plus`, and `times`.
- Methods that perform standard mathematical functions, such as `abs` and `average`).

Fields inherited from class oracle.olapi.data.source.Source
`COMPARISON_RULE_ASCENDING, COMPARISON_RULE_ASCENDING_NULLS_FIRST, COMPARISON_RULE_ASCENDING_NULLS_LAST, COMPARISON_RULE_DESCENDING, COMPARISON_RULE_DESCENDING_NULLS_FIRST, COMPARISON_RULE_DESCENDING_NULLS_LAST, COMPARISON_RULE_REMOVE, COMPARISON_RULE_SELECT`

Method Summary
`NumberSource` | `abs()` Calculates the absolute value of the value of each element of this `NumberSource`.
`NumberSource` | `appendValue(double appendValue)` Appends an element with the specified `double` value to this `NumberSource`.
`NumberSource` | `appendValue(float appendValue)` Appends an element with the specified `float` value to this `NumberSource`.
`NumberSource` | `appendValue(int appendValue)` Appends an element with the specified `int` value to this `NumberSource`.
`NumberSource` | `appendValue(short appendValue)` Appends an element with the specified `short` value to this `NumberSource`.
`NumberSource` | `appendValues(double[] appendValues)` Appends elements with the specified `double` values to this `NumberSource`.
`NumberSource` | `appendValues(float[] appendValues)` Appends elements with the specified `float` values to this `NumberSource`.
`NumberSource` | `appendValues(int[] appendValues)` Appends elements with the specified `int` values to this `NumberSource`.
`NumberSource` | `appendValues(short[] appendValues)` Appends elements with the specified `short` values to this `NumberSource`.
`NumberSource` | `arccos()` Calculates the angle value (in radians) of the value (interpreted as a cosine) of each element of this `NumberSource`.
`NumberSource` | `arcsin()` Calculates the angle value (in radians) of the value (interpreted as a sine) of each element of this `NumberSource`.
`NumberSource` | `arctan()` Calculates the angle value (in radians) of the value (interpreted as a tangent) of each element of this `NumberSource`.
`NumberSource` | `average()` Calculates the average of the values of the elements of this `NumberSource`.
`NumberSource` | `cos()` Calculates the cosine of the value (interpreted as an angle value in radians) of each element of this `NumberSource`.
`NumberSource` | `cosh()` Calculates the hyperbolic cosine of the value (interpreted as an angle value in radians) of each element of this `NumberSource`.
`NumberSource` | `cumulativeAverage(MdmLevelHierarchy dimension, int offset)` For each element of this `NumberSource`, calculates the average of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`.
`NumberSource` | `cumulativeAverage(MdmLevelHierarchy dimension, int offset, MdmLevel resetLevel)` For each element of this `NumberSource`, calculates the average of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative average calculation reset at the level specified by `resetLevel`.
`NumberSource` | `cumulativeMaximum(MdmLevelHierarchy dimension, int offset)` For each element of this `NumberSource`, calculates the maximum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`.
`NumberSource` | `cumulativeMaximum(MdmLevelHierarchy dimension, int offset, MdmLevel resetLevel)` For each element of this `NumberSource`, calculates the maximum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative maximum calculation reset at the level specified by `resetLevel`.
`NumberSource` | `cumulativeMinimum(MdmLevelHierarchy dimension, int offset)` For each element of this `NumberSource`, calculates the minimum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`.
`NumberSource` | `cumulativeMinimum(MdmLevelHierarchy dimension, int offset, MdmLevel resetLevel)` For each element of this `NumberSource`, calculates the minimum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative minimum calculation reset at the level specified by `resetLevel`.
`NumberSource` | `cumulativeTotal(MdmLevelHierarchy dimension, int offset)` For each element of this `NumberSource`, calculates the total of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`.
`NumberSource` | `cumulativeTotal(MdmLevelHierarchy dimension, int offset, MdmLevel resetLevel)` For each element of this `NumberSource`, calculates the total of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative total calculation reset at the level specified by `resetLevel`.
`NumberSource` | `div(double rhs)` Divides the value of the elements of this `NumberSource` by the specified `double` value.
`NumberSource` | `div(double rhs, boolean safe)` Divides the value of the elements of this `NumberSource` by the specified `double` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
`NumberSource` | `div(float rhs)` Divides the value of the elements of this `NumberSource` by the specified `float` value.
`NumberSource` | `div(float rhs, boolean safe)` Divides the value of the elements of this `NumberSource` by the specified `float` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
`NumberSource` | `div(int rhs)` Divides the value of the elements of this `NumberSource` by the specified `int` value.
`NumberSource` | `div(int rhs, boolean safe)` Divides the value of the elements of this `NumberSource` by the specified `int` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
`NumberSource` | `div(NumberSource rhs)` Divides the value of the elements of this `NumberSource` by the values of the elements of the specified `NumberSource`.
`NumberSource` | `div(NumberSource rhs, boolean safe)` Divides the value of the elements of this `NumberSource` by the values of the elements of the specified `NumberSource`; if `safe` is `true` and a divisor is zero, then this method returns `null` as the result of the division.
`NumberSource` | `div(short rhs)` Divides the value of the elements of this `NumberSource` by the specified `short` value.
`NumberSource` | `div(short rhs, boolean safe)` Divides the value of the elements of this `NumberSource` by the specified `short` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
`BooleanSource` | `eq(double rhs)` Compares the value of each element of this `NumberSource` to the specified `double` value and determines if the values are equal.
`BooleanSource` | `eq(float rhs)` Compares the value of each element of this `NumberSource` to the specified `float` value and determines if the values are equal.
`BooleanSource` | `eq(int rhs)` Compares the value of each element of this `NumberSource` to the specified `int` value and determines if the values are equal.
`BooleanSource` | `eq(short rhs)` Compares the value of each element of this `NumberSource` to the specified `short` value and determines if the values are equal.
`BooleanSource` | `ge(double rhs)` Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a greater or equal value.
`BooleanSource` | `ge(float rhs)` Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a greater or equal value.
`BooleanSource` | `ge(int rhs)` Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a greater or equal value.
`BooleanSource` | `ge(short rhs)` Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a greater or equal value.
`Source` | `getDataType()` Gets the fundamental `Source` that represents the OLAP API data type of this `NumberSource`, which can be Double, Float, Integer, Number, or Short, depending on the values of its elements.
`BooleanSource` | `gt(double rhs)` Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a greater value.
`BooleanSource` | `gt(float rhs)` Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a greater value.
`BooleanSource` | `gt(int rhs)` Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a greater value.
`BooleanSource` | `gt(short rhs)` Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a greater value.
`NumberSource` | `intpart()` Identifies the integer portion of the value of each element of this `NumberSource`.
`NumberSource` | `lag(MdmLevelHierarchy dimension, int offset)` Selects the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are the `offset` number of values away from each value of the `dimension` hierarchy that is at the same level of the hierarchy.
`NumberSource` | `lagDays(MdmLevelHierarchy timeDim, int offset)` Selects the elements of this `NumberSource` that are specified by the day values of `timeDim` that are the `offset` number of days away from each day value of `timeDim`.
`NumberSource` | `lagMonths(MdmLevelHierarchy timeDim, int offset)` Selects the elements of this `NumberSource` that are specified by the month values of `timeDim` that are the `offset` number of months away from each month value of `timeDim`.
`NumberSource` | `lagQuarters(MdmLevelHierarchy timeDim, int offset)` Selects the elements of this `NumberSource` that are specified by the quarter values of `timeDim` that are the `offset` number of quarters away from each quarter value of `timeDim`.
`NumberSource` | `lagWeeks(MdmLevelHierarchy timeDim, int offset)` Selects the elements of this `NumberSource` that are specified by the week values of `timeDim` that are the `offset` number of weeks away from each week value of `timeDim`.
`NumberSource` | `lagYears(MdmLevelHierarchy timeDim, int offset)` Selects the elements of this `NumberSource` that are specified by the year values of `timeDim` that are the `offset` number of years away from each year value of `timeDim`.
`BooleanSource` | `le(double rhs)` Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a lesser or equal value.
`BooleanSource` | `le(float rhs)` Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a lesser or equal value.
`BooleanSource` | `le(int rhs)` Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a lesser or equal value.
`BooleanSource` | `le(short rhs)` Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a lesser or equal value.
`NumberSource` | `lead(MdmLevelHierarchy dimension, int offset)` Selects the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are the `offset` number of values away from each value of the `dimension` hierarchy that is at the same level of the hierarchy.
`NumberSource` | `log()` Calculates the natural logarithm of the value of each element of this `NumberSource`.
`BooleanSource` | `lt(double rhs)` Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a lesser value.
`BooleanSource` | `lt(float rhs)` Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a lesser value.
`BooleanSource` | `lt(int rhs)` Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a lesser value.
`BooleanSource` | `lt(short rhs)` Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a lesser value.
`NumberSource` | `maximum()` Identifies the largest value of the elements of this `NumberSource`.
`NumberSource` | `median()` Calculates the median values of the elements of this `NumberSource`.
`NumberSource` | `minimum()` Identifies the smallest value of the elements of this `NumberSource`.
`NumberSource` | `minus(double rhs)` Subtracts the specified `double` value from the value of each element of this `NumberSource`.
`NumberSource` | `minus(float rhs)` Subtracts the specified `float` value from the value of each element of this `NumberSource`.
`NumberSource` | `minus(int rhs)` Subtracts the specified `int` value from the value of each element of this `NumberSource`.
`NumberSource` | `minus(NumberSource rhs)` Subtracts the values of the elments of the specified `NumberSource` from the value of each element of this `NumberSource`.
`NumberSource` | `minus(short rhs)` Subtracts the specified `short` value from the value of each element of this `NumberSource`.
`NumberSource` | `movingAverage(MdmLevelHierarchy dimension, int startOffset, int endOffset)` For each element of this `NumberSource`, calculates the average of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`.
`NumberSource` | `movingMaximum(MdmLevelHierarchy dimension, int startOffset, int endOffset)` For each element of this `NumberSource`, determines the maximum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`.
`NumberSource` | `movingMinimum(MdmLevelHierarchy dimension, int startOffset, int endOffset)` For each element of this `NumberSource`, determines the minimum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`.
`NumberSource` | `movingTotal(MdmLevelHierarchy dimension, int startOffset, int endOffset)` For each element of this `NumberSource`, calculates the total of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`.
`BooleanSource` | `ne(double rhs)` Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is not equal to the value.
`BooleanSource` | `ne(float rhs)` Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is not equal to the value.
`BooleanSource` | `ne(int rhs)` Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is not equal to the value.
`BooleanSource` | `ne(short rhs)` Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is not equal to the value.
`NumberSource` | `negate()` Negates the value of each of the elements of this `NumberSource`.
`NumberSource` | `plus(double rhs)` Adds the specified `double` value to the value of each element of this `NumberSource`.
`NumberSource` | `plus(float rhs)` Adds the specified `float` value to the value of each element of this `NumberSource`.
`NumberSource` | `plus(int rhs)` Adds the specified `int` value to the value of each element of this `NumberSource`.
`NumberSource` | `plus(NumberSource rhs)` Adds the values of the elements of the specified `NumberSource` to the value of each element of this `NumberSource`.
`NumberSource` | `plus(short rhs)` Adds the specified `short` value to the value of each element of this `NumberSource`.
`NumberSource` | `positionalPeriodsAgo(MdmLevelHierarchy hierarchy, MdmLevel offsetLevel, int offset)` A utility function to compute hierarchy-based lead/lag.
`NumberSource` | `positionOfValue(double value)` Identifies the positions of elements in this `NumberSource` that have the specified `double` value.
`NumberSource` | `positionOfValue(float value)` Identifies the positions of elements in this `NumberSource` that have the specified `float` value.
`NumberSource` | `positionOfValue(int value)` Identifies the positions of elements in this `NumberSource` that have the specified `int` value.
`NumberSource` | `positionOfValue(short value)` Identifies the positions of elements in this `NumberSource` that have the specified `short` value.
`NumberSource` | `positionOfValues(double[] values)` Identifies the positions of elements in this `NumberSource` that have the specified `double` values.
`NumberSource` | `positionOfValues(float[] values)` Identifies the positions of elements in this `NumberSource` that have the specified `float` values.
`NumberSource` | `positionOfValues(int[] values)` Identifies the positions of elements in this `NumberSource` that have the specified `int` values.
`NumberSource` | `positionOfValues(short[] values)` Identifies the positions of elements in this `NumberSource` that have the specified `short` values.
`NumberSource` | `pow(double rhs)` Raises the value of each element of this `NumberSource` to the specified `double` value.
`NumberSource` | `pow(float rhs)` Raises the value of each element of this `NumberSource` to the specified `float` value.
`NumberSource` | `pow(int rhs)` Raises the value of each element of this `NumberSource` to the specified `int` value.
`NumberSource` | `pow(NumberSource rhs)` Raises the value of each element of this `NumberSource` to the values of the elements of the specified `NumberSource`.
`NumberSource` | `pow(short rhs)` Raises the value of each element of this `NumberSource` to the specified `short` value.
`NumberSource` | `rem(double rhs)` Divides the value of each element of this `NumberSource` by the specified `double` value and determines the remainder for each operation.
`NumberSource` | `rem(float rhs)` Divides the value of each element of this `NumberSource` by the specified `float` value and determines the remainder for each operation.
`NumberSource` | `rem(int rhs)` Divides the value of each element of this `NumberSource` by the specified `int` value and determines the remainder for each operation.
`NumberSource` | `rem(NumberSource rhs)` Divides the value of each element of this `NumberSource` by the values of the elements of the specified `NumberSource` and determines the remainder for each operation.
`NumberSource` | `rem(short rhs)` Divides the value of each element of this `NumberSource` by the specified `short` value and determines the remainder for each operation.
`NumberSource` | `removeValue(double value)` Removes the elements of this `NumberSource` that have the specified `double` value.
`NumberSource` | `removeValue(float value)` Removes the elements of this `NumberSource` that have the specified `float` value.
`NumberSource` | `removeValue(int value)` Removes the elements of this `NumberSource` that have the specified `int` value.
`NumberSource` | `removeValue(short value)` Removes the elements of this `NumberSource` that have the specified `double` value.
`NumberSource` | `removeValues(double[] values)` Removes the elements of this `NumberSource` that have the specified `double` values.
`NumberSource` | `removeValues(float[] values)` Removes the elements of this `NumberSource` that have the specified `float` values.
`NumberSource` | `removeValues(int[] values)` Removes the elements of this `NumberSource` that have the specified `int` values.
`NumberSource` | `removeValues(short[] values)` Removes the elements of this `NumberSource` that have the specified `short` values.
`NumberSource` | `round(double precision)` Rounds the value of each element of this `NumberSource` to the precision specified by the `double` value.
`NumberSource` | `round(float precision)` Rounds the value of each element of this `NumberSource` to the precision specified by the `float` value.
`NumberSource` | `round(int precision)` Rounds the value of each element of this `NumberSource` to the precision specified by the `int` value.
`NumberSource` | `round(NumberSource precision)` Rounds the value of each element of this `NumberSource` to the precisions specified by the `NumberSource`.
`NumberSource` | `round(short precision)` Rounds the value of each element of this `NumberSource` to the precision specified by the `short` value.
`NumberSource` | `selectValue(double value)` Selects the elements of this `NumberSource` that have the specified `double` value.
`NumberSource` | `selectValue(float value)` Selects the elements of this `NumberSource` that have the specified `float` value.
`NumberSource` | `selectValue(int value)` Selects the elements of this `NumberSource` that have the specified `int` value.
`NumberSource` | `selectValue(short value)` Selects the elements of this `NumberSource` that have the specified `short` value.
`NumberSource` | `selectValues(double[] values)` Selects the elements of this `NumberSource` that have the specified `double` values.
`NumberSource` | `selectValues(float[] values)` Selects the elements of this `NumberSource` that have the specified `float` values.
`NumberSource` | `selectValues(int[] values)` Selects the elements of this `NumberSource` that have the specified `int` values.
`NumberSource` | `selectValues(short[] values)` Selects the elements of this `NumberSource` that have the specified `short` values.
`NumberSource` | `sin()` Calculates the sine of the value (interpreted as an angle) of each element of this `NumberSource`.
`NumberSource` | `sinh()` Calculates the hyperbolic of the value (interpreted as an angle) of each element of this `NumberSource`.
`NumberSource` | `sqrt()` Calculates the square root of the value of each element of this `NumberSource`.
`NumberSource` | `stdev()` Calculates the standard deviation of the values of this `NumberSource`.
`NumberSource` | `stdevPop()` Calculates the population standard deviation of the values of this `NumberSource`.
`NumberSource` | `stdevSamp()` Calculates the cumulative sample standard deviation of the values of this `NumberSource`.
`NumberSource` | `tan()` Calculates the tangent of the value (interpreted as an angle) of each element of this `NumberSource`.
`NumberSource` | `tanh()` Calculates the hyperbolic tangent of the value (interpreted as an angle) of each element of this `NumberSource`.
`NumberSource` | `times(double rhs)` Multiplies the value of each element of this `NumberSource` by the specified `double` value.
`NumberSource` | `times(float rhs)` Multiplies the value of each element of this `NumberSource` by the specified `float` value.
`NumberSource` | `times(int rhs)` Multiplies the value of each element of this `NumberSource` by the specified `int` value.
`NumberSource` | `times(NumberSource rhs)` Multiplies the value of each element of this `NumberSource` by the values of the elements of the specified `NumberSource`.
`NumberSource` | `times(short rhs)` Multiplies the value of each element of this `NumberSource` by the specified `short` value.
`NumberSource` | `total()` Calculates the sum of the values of the elements of this `NumberSource`.
`NumberSource` | `variance()` Calculates the variance of the elements of this `NumberSource`.
`NumberSource` | `variancePop()` Calculates the population variance of the elements of this `NumberSource`.
`NumberSource` | `varianceSamp()` Calculates the sample variance of the elements of this `NumberSource`.

Methods inherited from class oracle.olapi.data.source.Source
`alias, appendValue, appendValues, appendValues, at, at, count, count, cumulativeInterval, cumulativeInterval, cumulativeInterval, distinct, eq, extract, findMatchFor, first, ge, getDataProvider, getDefinition, getExtractionInputs, getID, getInputs, getMetadataProvider, getMetadataProviderID, getModel, getOutputs, getRegularInputs, getType, gt, hasValue, in, interval, interval, isSubtypeOf, join, join, join, join, join, join, join, join, join, join, join, join, join, join, join, join, join, join, join, joinHidden, last, le, lt, movingInterval, movingInterval, ne, nullSource, offset, offset, position, position, positionOfValue, positionOfValues, positionOfValues, recursiveJoin, recursiveJoin, recursiveJoin, recursiveJoin, recursiveJoin, recursiveJoin, recursiveJoin, remove, removeValue, removeValues, removeValues, select, selectDescendants, selectValue, selectValues, selectValues, sortAscending, sortAscending, sortAscending, sortAscendingHierarchically, sortAscendingHierarchically, sortAscendingHierarchically, sortAscendingHierarchically, sortDescending, sortDescending, sortDescending, sortDescendingHierarchically, sortDescendingHierarchically, sortDescendingHierarchically, sortDescendingHierarchically, toDoubleSource, toFloatSource, toIntegerSource, toShortSource, toStringSource, value, value`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### abs

    public final NumberSource abs()

  Calculates the absolute value of the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has an element with a `double` value that is the absolute value of the value of the corresponding element of this `NumberSource`.

### appendValue

    public final NumberSource appendValue(double appendValue)

  Appends an element with the specified `double` value to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValue` - The `double` value that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has an additional appended element that has the specified `double` value.
  See Also:
    `Source.appendValue(Source appendValue)`

### appendValue

    public final NumberSource appendValue(float appendValue)

  Appends an element with the specified `float` value to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValue` - The `float` value that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has an additional appended element that has the specified `float` value.
  See Also:
    `Source.appendValue(Source appendValue)`

### appendValue

    public final NumberSource appendValue(int appendValue)

  Appends an element with the specified `int` value to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValue` - The `int` value that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has an additional appended element that has the specified `int` value.
  See Also:
    `Source.appendValue(Source appendValue)`

### appendValue

    public final NumberSource appendValue(short appendValue)

  Appends an element with the specified `short` value to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValue` - The `short` value that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has an additional appended element that has the specified `short` value.
  See Also:
    `Source.appendValue(Source appendValue)`

### appendValues

    public final NumberSource appendValues(double[] appendValues)

  Appends elements with the specified `double` values to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValues` - An array that has the `double` values that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has additional appended elements that have the specified `double` values.
  See Also:
    `Source.appendValues(Source values)`

### appendValues

    public final NumberSource appendValues(float[] appendValues)

  Appends elements with the specified `float` values to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValues` - An array that has the `float` values that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has additional appended elements that have the specified `float` values.
  See Also:
    `Source.appendValues(Source values)`

### appendValues

    public final NumberSource appendValues(int[] appendValues)

  Appends elements with the specified `int` values to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValues` - An array that has the `int` values that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has additional appended elements that have the specified `int` values.
  See Also:
    `Source.appendValues(Source values)`

### appendValues

    public final NumberSource appendValues(short[] appendValues)

  Appends elements with the specified `short` values to this `NumberSource`. The outputs of this `NumberSource`, if any, do not appear in the resulting `NumberSource`.
  Parameters:
    `appendValues` - An array that has the `short` values that you want to append to this `NumberSource`.
  Returns:
    A `NumberSource` that has the same elements as this `NumberSource` and that has additional appended elements that have the specified `short` values.
  See Also:
    `Source.appendValues(Source values)`

### arccos

    public final NumberSource arccos()

  Calculates the angle value (in radians) of the value (interpreted as a cosine) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the angle values (in radians) of the values of the corresponding elements of this `NumberSource`.

### arcsin

    public final NumberSource arcsin()

  Calculates the angle value (in radians) of the value (interpreted as a sine) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the angle values (in radians) of the values of the corresponding elements of this `NumberSource`.

### arctan

    public final NumberSource arctan()

  Calculates the angle value (in radians) of the value (interpreted as a tangent) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the angle values (in radians) of the values of the corresponding elements of this `NumberSource`.

### average

    public final NumberSource average()

  Calculates the average of the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` that has an element whose value is the average of the values of the elements of this `NumberSource`.

### cos

    public final NumberSource cos()

  Calculates the cosine of the value (interpreted as an angle value in radians) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the cosines of the values of the corresponding elements of this `NumberSource`.

### cosh

    public final NumberSource cosh()

  Calculates the hyperbolic cosine of the value (interpreted as an angle value in radians) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the hyperbolic cosines of the values of the corresponding elements of this `NumberSource`.

### div

    public final NumberSource div(double rhs)

  Divides the value of the elements of this `NumberSource` by the specified `double` value.
  Parameters:
    `rhs` - The `double` value that you want to use as the divisor.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### div

    public final NumberSource div(double rhs,
                                  boolean safe)

  Divides the value of the elements of this `NumberSource` by the specified `double` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
  Parameters:
    `rhs` - The `double` value that you want to use as the divisor.
    `safe` - A `boolean` that indicates whether you want this method to return `null` when the divisor is zero.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### div

    public final NumberSource div(float rhs)

  Divides the value of the elements of this `NumberSource` by the specified `float` value.
  Parameters:
    `rhs` - The `float` value that you want to use as the divisor.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### div

    public final NumberSource div(float rhs,
                                  boolean safe)

  Divides the value of the elements of this `NumberSource` by the specified `float` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
  Parameters:
    `rhs` - The `float` value that you want to use as the divisor.
    `safe` - A `boolean` that indicates whether you want this method to return `null` when the divisor is zero.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### div

    public final NumberSource div(int rhs)

  Divides the value of the elements of this `NumberSource` by the specified `int` value.
  Parameters:
    `rhs` - The `int` value that you want to use as the divisor.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### div

    public final NumberSource div(int rhs,
                                  boolean safe)

  Divides the value of the elements of this `NumberSource` by the specified `int` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
  Parameters:
    `rhs` - The `int` value that you want to use as the divisor.
    `safe` - A `boolean` that indicates whether you want this method to return `null` when the divisor is zero.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### div

    public final NumberSource div(NumberSource rhs)

  Divides the value of the elements of this `NumberSource` by the values of the elements of the specified `NumberSource`.
  Parameters:
    `rhs` - A `NumberSource` whose element values you want to use as divisors.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisors.

### div

    public final NumberSource div(NumberSource rhs,
                                  boolean safe)

  Divides the value of the elements of this `NumberSource` by the values of the elements of the specified `NumberSource`; if `safe` is `true` and a divisor is zero, then this method returns `null` as the result of the division.
  Parameters:
    `rhs` - The `NumberSource` whose element values you want to use as divisors.
    `safe` - A `boolean` that indicates whether you want this method to return `null` when the divisor is zero.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisors.

### div

    public final NumberSource div(short rhs)

  Divides the value of the elements of this `NumberSource` by the specified `short` value.
  Parameters:
    `rhs` - The `short` value that you want to use as the divisor.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### div

    public final NumberSource div(short rhs,
                                  boolean safe)

  Divides the value of the elements of this `NumberSource` by the specified `short` value; if `safe` is `true` and the divisor is zero, then this method returns `null`.
  Parameters:
    `rhs` - The `short` value that you want to use as the divisor.
    `safe` - A `boolean` that indicates whether you want this method to return `null` when the divisor is zero.
  Returns:
    A `NumberSource` whose elements have values that that are the result of dividing the values of the elements of this `NumberSource` by the specified divisor.

### eq

    public final BooleanSource eq(double rhs)

  Compares the value of each element of this `NumberSource` to the specified `double` value and determines if the values are equal.
  Parameters:
    `rhs` - The `double` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element that has a value of `true` when the value of the corresponding element of this `NumberSource` equals the specified `double` value or `false` when it does not.
  See Also:
    `Source.eq(Source rhs)`

### eq

    public final BooleanSource eq(float rhs)

  Compares the value of each element of this `NumberSource` to the specified `float` value and determines if the values are equal.
  Parameters:
    `rhs` - The `float` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element that has a value of `true` when the value of the corresponding element of this `NumberSource` equals the specified `float` value or `false` when it does not.
  See Also:
    `Source.eq(Source rhs)`

### eq

    public final BooleanSource eq(int rhs)

  Compares the value of each element of this `NumberSource` to the specified `int` value and determines if the values are equal.
  Parameters:
    `rhs` - The `int` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element that has a value of `true` when the value of the corresponding element of this `NumberSource` equals the specified `int` value or `false` when it does not.
  See Also:
    `Source.eq(Source rhs)`

### eq

    public final BooleanSource eq(short rhs)

  Compares the value of each element of this `NumberSource` to the specified `short` value and determines if the values are equal.
  Parameters:
    `rhs` - The `short` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element that has a value of `true` when the value of the corresponding element of this `NumberSource` equals the specified `short` value or `false` when it does not.
  See Also:
    `Source.eq(Source rhs)`

### ge

    public final BooleanSource ge(double rhs)

  Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a greater or equal value.
  Parameters:
    `rhs` - The `double` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than or equal to the specified `double` value, or `false` when it is not.
  See Also:
    `Source.ge(Source rhs)`

### ge

    public final BooleanSource ge(float rhs)

  Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a greater or equal value.
  Parameters:
    `rhs` - The `float` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than or equal to the specified `float` value, or `false` when it is not.
  See Also:
    `Source.ge(Source rhs)`

### ge

    public final BooleanSource ge(int rhs)

  Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a greater or equal value.
  Parameters:
    `rhs` - The `int` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than or equal to the specified `int` value, or `false` when it is not.
  See Also:
    `Source.ge(Source rhs)`

### ge

    public final BooleanSource ge(short rhs)

  Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a greater or equal value.
  Parameters:
    `rhs` - The `short` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than or equal to the specified `short` value, or `false` when it is not.
  See Also:
    `Source.ge(Source rhs)`

### getDataType

    public Source getDataType()

  Gets the fundamental `Source` that represents the OLAP API data type of this `NumberSource`, which can be Double, Float, Integer, Number, or Short, depending on the values of its elements.
  Overrides:
    getDataType in class Source
  Returns:
    The fundamental `Source` that represents the OLAP API data type of this `NumberSource`.

### gt

    public final BooleanSource gt(double rhs)

  Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a greater value.
  Parameters:
    `rhs` - The `double` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than the specified `double` value, or `false` when it is not.
  See Also:
    `Source.gt(Source rhs)`

### gt

    public final BooleanSource gt(float rhs)

  Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a greater value.
  Parameters:
    `rhs` - The `float` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than the specified `float` value, or `false` when it is not.
  See Also:
    `Source.gt(Source rhs)`

### gt

    public final BooleanSource gt(int rhs)

  Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a greater value.
  Parameters:
    `rhs` - The `int` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than the specified `int` value, or `false` when it is not.
  See Also:
    `Source.gt(Source rhs)`

### gt

    public final BooleanSource gt(short rhs)

  Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a greater value.
  Parameters:
    `rhs` - The `short` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is greater than the specified `short` value, or `false` when it is not.
  See Also:
    `Source.gt(Source rhs)`

### intpart

    public final NumberSource intpart()

  Identifies the integer portion of the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have the integer portion of the values of the elements of this `NumberSource`.

### le

    public final BooleanSource le(double rhs)

  Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a lesser or equal value.
  Parameters:
    `rhs` - The `double` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of a given element of this `NumberSource` is less than or equal to the specified `double` value, or `false` when it is not.
  See Also:
    `Source.le(Source rhs)`

### le

    public final BooleanSource le(float rhs)

  Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a lesser or equal value.
  Parameters:
    `rhs` - The `float` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of a given element of this `NumberSource` is less than or equal to the specified `float` value, or `false` when it is not.
  See Also:
    `Source.le(Source rhs)`

### le

    public final BooleanSource le(int rhs)

  Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a lesser or equal value.
  Parameters:
    `rhs` - The `int` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of a given element of this `NumberSource` is less than or equal to the specified `int` value, or `false` when it is not.
  See Also:
    `Source.le(Source rhs)`

### le

    public final BooleanSource le(short rhs)

  Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a lesser or equal value.
  Parameters:
    `rhs` - The `short` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of a given element of this `NumberSource` is less than or equal to the specified `short` value, or `false` when it is not.
  See Also:
    `Source.le(Source rhs)`

### log

    public final NumberSource log()

  Calculates the natural logarithm of the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has `double` values that are the natural logarithms of the values of the elements of this `NumberSource`.

### lt

    public final BooleanSource lt(double rhs)

  Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is a lesser value.
  Parameters:
    `rhs` - The `double` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is less than the specified `double` value, or `false` when it is not.
  See Also:
    `Source.lt(Source rhs)`

### lt

    public final BooleanSource lt(float rhs)

  Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is a lesser value.
  Parameters:
    `rhs` - The `float` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is less than the specified `float` value, or `false` when it is not.
  See Also:
    `Source.lt(Source rhs)`

### lt

    public final BooleanSource lt(int rhs)

  Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is a lesser value.
  Parameters:
    `rhs` - The `int` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is less than the specified `int` value, or `false` when it is not.
  See Also:
    `Source.lt(Source rhs)`

### lt

    public final BooleanSource lt(short rhs)

  Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is a lesser value.
  Parameters:
    `rhs` - The `short` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is less than the specified `short` value, or `false` when it is not.
  See Also:
    `Source.lt(Source rhs)`

### maximum

    public final NumberSource maximum()

  Identifies the largest value of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` that has an element whose value is the largest value of the elements of this `NumberSource`.

### minimum

    public final NumberSource minimum()

  Identifies the smallest value of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` that has an element whose value is the smallest value of the elements of this `NumberSource`.

### minus

    public final NumberSource minus(double rhs)

  Subtracts the specified `double` value from the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `double` value that you want to subtract from the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource`, each of whose elements has a value that results from subtracting the specified `double` value from the value of the corresponding element of this `NumberSource`.

### minus

    public final NumberSource minus(float rhs)

  Subtracts the specified `float` value from the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `float` value that you want to subtract from the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource`, each of whose elements has a value that results from subtracting the specified `float` value from the value of the corresponding element of this `NumberSource`.

### minus

    public final NumberSource minus(int rhs)

  Subtracts the specified `int` value from the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `int` value that you want to subtract from the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource`, each of whose elements has a value that results from subtracting the specified `int` value from the value of the corresponding element of this `NumberSource`.

### minus

    public final NumberSource minus(NumberSource rhs)

  Subtracts the values of the elments of the specified `NumberSource` from the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `NumberSource`, the values of whose elements you want to subtract from the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that result from subtracting the values of the elements of the specified `NumberSource` from the values of the elements of this `NumberSource`.

### minus

    public final NumberSource minus(short rhs)

  Subtracts the specified `short` value from the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `short` value that you want to subtract from the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource`, each of whose elements has a value that results from subtracting the specified `short` value from the value of the corresponding element of this `NumberSource`.

### ne

    public final BooleanSource ne(double rhs)

  Compares the value of each element of this `NumberSource` to the specified `double` value, and determines whether it is not equal to the value.
  Parameters:
    `rhs` - The `double` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is not equal to the specified `double` value, or `false` when it is equal to the specified value.
  See Also:
    `Source.ne(Source rhs)`

### ne

    public final BooleanSource ne(float rhs)

  Compares the value of each element of this `NumberSource` to the specified `float` value, and determines whether it is not equal to the value.
  Parameters:
    `rhs` - The `float` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is not equal to the specified `float` value, or `false` when it is equal to the specified value.
  See Also:
    `Source.ne(Source rhs)`

### ne

    public final BooleanSource ne(int rhs)

  Compares the value of each element of this `NumberSource` to the specified `int` value, and determines whether it is not equal to the value.
  Parameters:
    `rhs` - The `int` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is not equal to the specified `int` value, or `false` when it is equal to the specified value.
  See Also:
    `Source.ne(Source rhs)`

### ne

    public final BooleanSource ne(short rhs)

  Compares the value of each element of this `NumberSource` to the specified `short` value, and determines whether it is not equal to the value.
  Parameters:
    `rhs` - The `short` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `BooleanSource` that has an element with a value of `true` when the value of the corresponding element of this `NumberSource` is not equal to the specified `short` value, or `false` when it is equal to the specified value.
  See Also:
    `Source.ne(Source rhs)`

### negate

    public final NumberSource negate()

  Negates the value of each of the elements of this `NumberSource`.
  Returns:
    A `NumberSource`, the values of whose elements are the negative values of the values of the corresponding elements of this `NumberSource`.

### plus

    public final NumberSource plus(double rhs)

  Adds the specified `double` value to the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `double` value that you want to add to the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` with the specified `double` value added to them.

### plus

    public final NumberSource plus(float rhs)

  Adds the specified `float` value to the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `float` value that you want to add to the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` with the specified `float` value added to them.

### plus

    public final NumberSource plus(int rhs)

  Adds the specified `int` value to the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `int` value that you want to add to the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` with the specified `int` value added to them.

### plus

    public final NumberSource plus(NumberSource rhs)

  Adds the values of the elements of the specified `NumberSource` to the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `NumberSource` the values of the elements of which you want to add to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the elements of this `NumberSource` with the values of the elements of the specified `NumberSource` added to them.

### plus

    public final NumberSource plus(short rhs)

  Adds the specified `short` value to the value of each element of this `NumberSource`.
  Parameters:
    `rhs` - The `short` value that you want to add to the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` with the specified `short` value added to them.

### positionOfValue

    public final NumberSource positionOfValue(double value)

  Identifies the positions of elements in this `NumberSource` that have the specified `double` value.
  Parameters:
    `value` - The `double` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `double` value. If this `NumberSource` does not have any elements that have the specified value, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### positionOfValue

    public final NumberSource positionOfValue(float value)

  Identifies the positions of elements in this `NumberSource` that have the specified `float` value.
  Parameters:
    `value` - The `float` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `float` value. If this `NumberSource` does not have any elements that have the specified value, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### positionOfValue

    public final NumberSource positionOfValue(int value)

  Identifies the positions of elements in this `NumberSource` that have the specified `int` value.
  Parameters:
    `value` - The `int` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `int` value. If this `NumberSource` does not have any elements that have the specified value, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### positionOfValue

    public final NumberSource positionOfValue(short value)

  Identifies the positions of elements in this `NumberSource` that have the specified `short` value.
  Parameters:
    `value` - The `short` value that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `short` value. If this `NumberSource` does not have any elements that have the specified value, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### positionOfValues

    public final NumberSource positionOfValues(double[] values)

  Identifies the positions of elements in this `NumberSource` that have the specified `double` values.
  Parameters:
    `values` - An array of `double` values that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `double` values. If this `NumberSource` does not have any elements that have the specified values, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### positionOfValues

    public final NumberSource positionOfValues(float[] values)

  Identifies the positions of elements in this `NumberSource` that have the specified `float` values.
  Parameters:
    `values` - An array of `float` values that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `float` values. If this `NumberSource` does not have any elements that have the specified values, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### positionOfValues

    public final NumberSource positionOfValues(int[] values)

  Identifies the positions of elements in this `NumberSource` that have the specified `int` values.
  Parameters:
    `values` - An array of `int` values that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `int` values. If this `NumberSource` does not have any elements that have the specified values, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### positionOfValues

    public final NumberSource positionOfValues(short[] values)

  Identifies the positions of elements in this `NumberSource` that have the specified `short` values.
  Parameters:
    `values` - An array of `short` values that you want to compare to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `int` values that identify the positions of the elements in this `NumberSource` that have the specified `short` values. If this `NumberSource` does not have any elements that have the specified values, then this method returns an empty `NumberSource`, which has no elements.
  See Also:
    `Source.positionOfValue(Source value)`

### pow

    public final NumberSource pow(double rhs)

  Raises the value of each element of this `NumberSource` to the specified `double` value.
  Parameters:
    `rhs` - The `double` value by which you want to raise the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` raised to the power of the specified `double` value.

### pow

    public final NumberSource pow(float rhs)

  Raises the value of each element of this `NumberSource` to the specified `float` value.
  Parameters:
    `rhs` - The `float` value by which you want to raise the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` raised to the power of the specified `float` value.

### pow

    public final NumberSource pow(int rhs)

  Raises the value of each element of this `NumberSource` to the specified `int` value.
  Parameters:
    `rhs` - The `int` value by which you want to raise the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` raised to the power of the specified `int` value.

### pow

    public final NumberSource pow(NumberSource rhs)

  Raises the value of each element of this `NumberSource` to the values of the elements of the specified `NumberSource`.
  Parameters:
    `rhs` - The `NumberSource`, the values of whose elements you want to raise to the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the elements of this `NumberSource` raised to the values of the elements of the specified `NumberSource`.

### pow

    public final NumberSource pow(short rhs)

  Raises the value of each element of this `NumberSource` to the specified `short` value.
  Parameters:
    `rhs` - The `short` value by which you want to raise the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` that has elements that have the values of the corresponding elements of this `NumberSource` raised to the power of the specified `short` value.

### rem

    public final NumberSource rem(double rhs)

  Divides the value of each element of this `NumberSource` by the specified `double` value and determines the remainder for each operation.
  Parameters:
    `rhs` - The `double` value that you want to divide into the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that are the remainders of dividing the values of the elements of this `NumberSource` by the specified `double` value.

### rem

    public final NumberSource rem(float rhs)

  Divides the value of each element of this `NumberSource` by the specified `float` value and determines the remainder for each operation.
  Parameters:
    `rhs` - The `float` value that you want to divide into the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that are the remainders of dividing the values of the elements of this `NumberSource` by the specified `float` value.

### rem

    public final NumberSource rem(int rhs)

  Divides the value of each element of this `NumberSource` by the specified `int` value and determines the remainder for each operation.
  Parameters:
    `rhs` - The `int` value that you want to divide into the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that are the remainders of dividing the values of the elements of this `NumberSource` by the specified `int` value.

### rem

    public final NumberSource rem(NumberSource rhs)

  Divides the value of each element of this `NumberSource` by the values of the elements of the specified `NumberSource` and determines the remainder for each operation.
  Parameters:
    `rhs` - The `NumberSource`, the values of whose elements by which you want to divide the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that are the remainders of dividing the values of the elements of this `NumberSource` by the values of the elements of the specified `NumberSource`.

### rem

    public final NumberSource rem(short rhs)

  Divides the value of each element of this `NumberSource` by the specified `short` value and determines the remainder for each operation.
  Parameters:
    `rhs` - The `short` value that you want to divide into the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that are the remainders of dividing the values of the elements of this `NumberSource` by the specified `short` value.

### removeValue

    public final NumberSource removeValue(double value)

  Removes the elements of this `NumberSource` that have the specified `double` value.
  Parameters:
    `value` - The `double` value you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `double` value.
  See Also:
    `Source.removeValue(Source value)`

### removeValue

    public final NumberSource removeValue(float value)

  Removes the elements of this `NumberSource` that have the specified `float` value.
  Parameters:
    `value` - The `float` value you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `float` value.
  See Also:
    `Source.removeValue(Source value)`

### removeValue

    public final NumberSource removeValue(int value)

  Removes the elements of this `NumberSource` that have the specified `int` value.
  Parameters:
    `value` - The `int` value you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `int` value.
  See Also:
    `Source.removeValue(Source value)`

### removeValue

    public final NumberSource removeValue(short value)

  Removes the elements of this `NumberSource` that have the specified `double` value.
  Parameters:
    `value` - The `double` value you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `double` value.
  See Also:
    `Source.removeValue(Source value)`

### removeValues

    public final NumberSource removeValues(double[] values)

  Removes the elements of this `NumberSource` that have the specified `double` values.
  Parameters:
    `values` - An array of the `double` values that you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `double` values.
  See Also:
    `Source.removeValues(Source values)`

### removeValues

    public final NumberSource removeValues(float[] values)

  Removes the elements of this `NumberSource` that have the specified `float` values.
  Parameters:
    `values` - An array of the `float` values that you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `float` values.
  See Also:
    `Source.removeValues(Source values)`

### removeValues

    public final NumberSource removeValues(int[] values)

  Removes the elements of this `NumberSource` that have the specified `int` values.
  Parameters:
    `values` - An array of the `int` values that you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `int` values.
  See Also:
    `Source.removeValues(Source values)`

### removeValues

    public final NumberSource removeValues(short[] values)

  Removes the elements of this `NumberSource` that have the specified `short` values.
  Parameters:
    `values` - An array of the `short` values that you do not want to have in the returned `NumberSource`.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that do not have the specified `short` values.
  See Also:
    `Source.removeValues(Source values)`

### round

    public final NumberSource round(double precision)

  Rounds the value of each element of this `NumberSource` to the precision specified by the `double` value.
  Parameters:
    `precision` - The `double` value that specifies the precision.
  Returns:
    A `NumberSource` whose elements have the values of this `NumberSource` rounded to the precision specified by the `double` value.

### round

    public final NumberSource round(float precision)

  Rounds the value of each element of this `NumberSource` to the precision specified by the `float` value.
  Parameters:
    `precision` - The `float` value that specifies the precision.
  Returns:
    A `NumberSource` whose elements have the values of this `NumberSource` rounded to the precision specified by the `float` value.

### round

    public final NumberSource round(int precision)

  Rounds the value of each element of this `NumberSource` to the precision specified by the `int` value.
  Parameters:
    `precision` - The `int` value that specifies the precision.
  Returns:
    A `NumberSource` whose elements have the values of this `NumberSource` rounded to the precision specified by the `int` value.

### round

    public final NumberSource round(NumberSource precision)

  Rounds the value of each element of this `NumberSource` to the precisions specified by the `NumberSource`.
  Parameters:
    `precision` - A `NumberSource` whose elements specify the precision values.
  Returns:
    A `NumberSource` whose elements have the values of this `NumberSource` rounded to the precisions specified by the `double` value.

### round

    public final NumberSource round(short precision)

  Rounds the value of each element of this `NumberSource` to the precision specified by the `short` value.
  Parameters:
    `precision` - The `short` value that specifies the precision.
  Returns:
    A `NumberSource` whose elements have the values of this `NumberSource` rounded to the precision specified by the `short` value.

### selectValue

    public final NumberSource selectValue(double value)

  Selects the elements of this `NumberSource` that have the specified `double` value.
  Parameters:
    `value` - The `double` value of the elements that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `double` value.
  See Also:
    `Source.selectValue(Source value)`

### selectValue

    public final NumberSource selectValue(float value)

  Selects the elements of this `NumberSource` that have the specified `float` value.
  Parameters:
    `value` - The `float` value of the elements that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `float` value.
  See Also:
    `Source.selectValue(Source value)`

### selectValue

    public final NumberSource selectValue(int value)

  Selects the elements of this `NumberSource` that have the specified `int` value.
  Parameters:
    `value` - The `int` value of the elements that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `int` value.
  See Also:
    `Source.selectValue(Source value)`

### selectValue

    public final NumberSource selectValue(short value)

  Selects the elements of this `NumberSource` that have the specified `short` value.
  Parameters:
    `value` - The `short` value of the elements that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `short` value.
  See Also:
    `Source.selectValue(Source value)`

### selectValues

    public final NumberSource selectValues(double[] values)

  Selects the elements of this `NumberSource` that have the specified `double` values.
  Parameters:
    `values` - An array of the `double` values that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `double` values.

### selectValues

    public final NumberSource selectValues(float[] values)

  Selects the elements of this `NumberSource` that have the specified `float` values.
  Parameters:
    `values` - An array of the `float` values that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `float` values.
  See Also:
    `Source.selectValues(Source values)`

### selectValues

    public final NumberSource selectValues(int[] values)

  Selects the elements of this `NumberSource` that have the specified `int` values.
  Parameters:
    `values` - An array of the `int` values that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `int` values.
  See Also:
    `Source.selectValues(Source values)`

### selectValues

    public final NumberSource selectValues(short[] values)

  Selects the elements of this `NumberSource` that have the specified `short` values.
  Parameters:
    `values` - An array of the `short` values that you want the returned `NumberSource` to have.
  Returns:
    A `NumberSource` that has only those elements of this `NumberSource` that have the specified `short` values.
  See Also:
    `Source.selectValues(Source values)`

### sin

    public final NumberSource sin()

  Calculates the sine of the value (interpreted as an angle) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the sines of the values of the elements of this `NumberSource`.

### sinh

    public final NumberSource sinh()

  Calculates the hyperbolic of the value (interpreted as an angle) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the hyperbolic sines of the values of the elements of this `NumberSource`.

### sqrt

    public final NumberSource sqrt()

  Calculates the square root of the value of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the square roots of the values of the elements of this `NumberSource`.

### stdev

    public final NumberSource stdev()

  Calculates the standard deviation of the values of this `NumberSource`. This method ignores elements with null values.
  Returns:
    A `NumberSource` whose elements have values that are the standard deviations of the values of the elements of this `NumberSource`.

### tan

    public final NumberSource tan()

  Calculates the tangent of the value (interpreted as an angle) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the tangents of the values of the elements of this `NumberSource`.

### tanh

    public final NumberSource tanh()

  Calculates the hyperbolic tangent of the value (interpreted as an angle) of each element of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have `double` values that are the interpreted tangents of the values of the elements of this `NumberSource`.

### times

    public final NumberSource times(double rhs)

  Multiplies the value of each element of this `NumberSource` by the specified `double` value.
  Parameters:
    `rhs` - The `double` value by which you want to multiply the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have the `double` values that result from multiplying the values of the elements of this `NumberSource` by the specified value.

### times

    public final NumberSource times(float rhs)

  Multiplies the value of each element of this `NumberSource` by the specified `float` value.
  Parameters:
    `rhs` - The `float` value by which you want to multiply the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have the `float` values that result from multiplying the values of the elements of this `NumberSource` by the specified value.

### times

    public final NumberSource times(int rhs)

  Multiplies the value of each element of this `NumberSource` by the specified `int` value.
  Parameters:
    `rhs` - The `int` value by which you want to multiply the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have the `int` values that result from multiplying the values of the elements of this `NumberSource` by the specified value.

### times

    public final NumberSource times(NumberSource rhs)

  Multiplies the value of each element of this `NumberSource` by the values of the elements of the specified `NumberSource`.
  Parameters:
    `rhs` - A `NumberSource` that has elements that have the values by which you want to multiply the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have the values that result from multiplying the values of the elements of this `NumberSource` by the values of the elements of the specified `NumberSource`.

### times

    public final NumberSource times(short rhs)

  Multiplies the value of each element of this `NumberSource` by the specified `short` value.
  Parameters:
    `rhs` - The `short` value by which you want to multiply the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have the `short` values that result from multiplying the values of the elements of this `NumberSource` by the specified value.

### total

    public final NumberSource total()

  Calculates the sum of the values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` that has an element whose value is sum of the values of the elements of this `NumberSource`.

### lead

    public final NumberSource lead(MdmLevelHierarchy dimension,
                                   int offset)

  Selects the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are the `offset` number of values away from each value of the `dimension` hierarchy that is at the same level of the hierarchy. If this `NumberSource` does not have an element at the specified `offset`, then the value of the corresponding element of the `NumberSource` returned by this method is `null`. Call this method only on a `NumberSource` for an `MdmMeasure`.

  When this `NumberSource` is the `Source` for an `MdmMeasure` that has an `MdmTimeDimension` as an input dimension, and when `dimension` is an `MdmLevelHierarchy` component of the `MdmTimeDimension`, then this method uses the end date and the timespan of the value of each element of the hierarchy of time periods to calculate the start of each value. This method then finds the element of the time hierarchy that has the value that is the `offset` number of time periods at the same level of the hierarchy away from the start date of the value.

  In the following example, `unitPrice` is the `NumberSource` for an `MdmMeasure` of prices of product units. The `mdmTimeDefLvlHier` object is the `MdmLevelHierarchy` returned by the `getDefaultHierarchy` method of an `MdmTimeDimension`.

  The input dimensions of the `unitPrice` measure are the Product and Time dimensions. The `timeSel` object specifies the first nine months of the year 2002, and `prodSel` specifies `PRODUCT_ROLLUP::FAMILY::5`, which is the Desktop PCs family of the default hierarchy of the Product dimension. The `joinHidden` method causes the product selection to not appear as an output of `leadResult`.

       NumberSource unitPriceLead3 = unitPrice.lead(mdmTimeDefLvlHier, 3);
       Source measuresDim = dp.createListSource(new Source[] {unitPrice,
                                                              unitPriceLead3});

       Source leadResult = measuresDim.extract()
                                      .join(measuresDim)
                                      .join(timeSel)
                                      .joinHidden(prodSel);

  A `Cursor` for `leadResult` has the following values, which are displayed with headings for the Product value `5`, (Desktop PCs), months, unit price, and the unit price in three months. The `Source` identifications (IDs) that are the values of the output of `leadResult`, which come from joining `measuresDim` to the object returned by the `measureDim.extract()` method, do not appear in the display. Unit price values have had trailing zeros added.

       Product Family: Desktop PCs
       ---------------------------
                 Month       Unit Price  Unit Price in Three Months
       -------------------   ----------  --------------------------

       CALENDAR::MONTH::69   10583.30    10567.64
       CALENDAR::MONTH::70   10495.74    10598.20
       CALENDAR::MONTH::71   10585.30    10768.12
       CALENDAR::MONTH::72   10567.64    10698.62
       CALENDAR::MONTH::73   10598.20    10656.12
       CALENDAR::MONTH::74   10768.12    10648.90
       CALENDAR::MONTH::75   10698.62    10614.42
       CALENDAR::MONTH::76   10656.12    10546.30
       CALENDAR::MONTH::77   10648.90    10106.24

  The display of the values of `leadResult` shows that, for each element of the `unitPrice` measure, the corresponding element of the `unitPriceLead3` measure has the value of the `unitPrice` element that is three time periods after the current element. For example, the `unitPriceLead3` value for `CALENDAR::MONTH::69` (January, 2002) is the `unitPrice` value for `CALENDAR::MONTH::72` (April, 2002), and so on.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents. Typically, this dimension is a hierarchy of an `MdmTimeDimension`.
    `offset` - The number of values at the same level of the hierarchy to add to or subtract from the value of an element of the `dimension` hierarchy.
  See Also:
    `lag(MdmLevelHierarchy dimension, int offset)`

### lag

    public final NumberSource lag(MdmLevelHierarchy dimension,
                                  int offset)

  Selects the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are the `offset` number of values away from each value of the `dimension` hierarchy that is at the same level of the hierarchy. If this `NumberSource` does not have an element at the specified `offset`, then the value of the corresponding element of the `NumberSource` returned by this method is `null`. Call this method only on a `NumberSource` for an `MdmMeasure`.

  This method operates in a way similar to the `lead` method, and when the `offset` value is negative, the method produces the same result as the `lead` method with a positive `offset`. The following example uses the same objects as the example in the description of the `lead` method except for the `unitPriceLag3` object that is returned by calling the `lag` method of the `unitPrice` object.

       NumberSource unitPriceLag3 = unitPrice.lag(mdmTimeDefLvlHier, 3);
       measuresDim = dp.createListSource(new Source[] {unitPrice,
                                                       unitPriceLag3});

       Source lagResult = measuresDim.extract()
                                     .join(measuresDim)
                                     .join(timeSel)
                                     .joinHidden(prodSel);

  A `Cursor` for `lagResult` has the following values, which are displayed with headings for the Product value `5`, (Desktop PCs), months, unit price, and the unit price three months before, and with trailing zeros added to the unit price values. The `Source` identifications (IDs) that are the values of the output of `lagResult`, which come from joining `measuresDim` to the object returned by the `measureDim.extract()` method, do not appear in the display.

       Product Family: Desktop PCs
       ---------------------------
              Month          Unit Price  Unit Price Three Months Before
       -------------------   ----------  ------------------------------

       CALENDAR::MONTH::69   10583.30     5579.93
       CALENDAR::MONTH::70   10495.74     5459.35
       CALENDAR::MONTH::71   10585.30     5416.90
       CALENDAR::MONTH::72   10567.64    10583.30
       CALENDAR::MONTH::73   10598.20    10495.74
       CALENDAR::MONTH::74   10768.12    10585.30
       CALENDAR::MONTH::75   10698.62    10567.64
       CALENDAR::MONTH::76   10656.12    10598.20
       CALENDAR::MONTH::77   10648.90    10768.12

  The display of the values of `lagResult` shows that, for each element of the `unitPrice` measure, the corresponding element of the `unitPriceLag3` measure has the value of the `unitPrice` element that is three time periods before the current element. For example, the `unitPriceLead3` value for `CALENDAR::MONTH::72` (April, 2002) is the `unitPrice` value for `CALENDAR::MONTH::69` (January, 2002), and so on.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents. Typically, this dimension is a hierarchy of an `MdmTimeDimension`.
    `offset` - The number of values at the same level of the hierarchy to add to or subtract from the value of an element of the `dimension` hierarchy.
  See Also:
    `lead(MdmLevelHierarchy dimension, int offset)`

### lagMonths

    public final NumberSource lagMonths(MdmLevelHierarchy timeDim,
                                        int offset)

  Selects the elements of this `NumberSource` that are specified by the month values of `timeDim` that are the `offset` number of months away from each month value of `timeDim`. If `timeDim` does not have an element at the specified `offset`, then the value of the corresponding element of the `NumberSource` returned by this method is `null`. Call this method only on a `NumberSource` for an `MdmMeasure` that has an `MdmTimeDimension` as an input dimension.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmTimeDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of months to add to or subtract from the month values of the elements of the `timeDim` hierarchy.
  See Also:
    `lag(MdmLevelHierarchy dimension, int offset)`

### lagQuarters

    public final NumberSource lagQuarters(MdmLevelHierarchy timeDim,
                                          int offset)

  Selects the elements of this `NumberSource` that are specified by the quarter values of `timeDim` that are the `offset` number of quarters away from each quarter value of `timeDim`. If `timeDim` does not have an element at the specified `offset`, then the value of the corresponding element of the `NumberSource` returned by this method is `null`. Call this method only on a `NumberSource` for an `MdmMeasure` that has an `MdmTimeDimension` as an input dimension.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmTimeDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of quarters to add to or subtract from the quarter values of the elements of the `timeDim` hierarchy.
  See Also:
    `lag(MdmLevelHierarchy dimension, int offset)`

### lagYears

    public final NumberSource lagYears(MdmLevelHierarchy timeDim,
                                       int offset)

  Selects the elements of this `NumberSource` that are specified by the year values of `timeDim` that are the `offset` number of years away from each year value of `timeDim`. If `timeDim` does not have an element at the specified `offset`, then the value of the corresponding element of the `NumberSource` returned by this method is `null`. Call this method only on a `NumberSource` for an `MdmMeasure` that has an `MdmTimeDimension` as an input dimension.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmTimeDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of years to add to or subtract from the year values of the elements of the `timeDim` hierarchy.
  See Also:
    `lag(MdmLevelHierarchy dimension, int offset)`

### lagDays

    public final NumberSource lagDays(MdmLevelHierarchy timeDim,
                                      int offset)

  Selects the elements of this `NumberSource` that are specified by the day values of `timeDim` that are the `offset` number of days away from each day value of `timeDim`. If `timeDim` does not have an element at the specified `offset`, then the value of the corresponding element of the `NumberSource` returned by this method is `null`. Call this method only on a `NumberSource` for an `MdmMeasure` that has an `MdmTimeDimension` as an input dimension.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmTimeDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of days to add to or subtract from the day values of the elements of the `timeDim` hierarchy.
  See Also:
    `lag(MdmLevelHierarchy dimension, int offset)`

### lagWeeks

    public final NumberSource lagWeeks(MdmLevelHierarchy timeDim,
                                       int offset)

  Selects the elements of this `NumberSource` that are specified by the week values of `timeDim` that are the `offset` number of weeks away from each week value of `timeDim`. If `timeDim` does not have an element at the specified `offset`, then the value of the corresponding element of the `NumberSource` returned by this method is `null`. Call this method only on a `NumberSource` for an `MdmMeasure` that has an `MdmTimeDimension` as an input dimension.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmTimeDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of weeks to add to or subtract from the week values of the elements of the `timeDim` hierarchy.
  See Also:
    `lag(MdmLevelHierarchy dimension, int offset)`

### cumulativeTotal

    public final NumberSource cumulativeTotal(MdmLevelHierarchy dimension,
                                              int offset)

  For each element of this `NumberSource`, calculates the total of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`. Call this method only on a `NumberSource` for an `MdmMeasure`.

  In the following example, `unitPrice` is the `NumberSource` for an `MdmMeasure` of prices of product units. The `mdmTimeDefLvlHier` object is the `MdmLevelHierarchy` returned by the `getDefaultHierarchy` method of an `MdmTimeDimension`. The default hierarchy is calendar year time periods, and it is named `CALENDAR`.

  The input dimensions of the `unitPrice` measure are products and times. The `timeSel` object specifies the first three months of 2001, the quarters of the years 2001 and 2002, and the years 2001 and 2002. The `prodSel` object specifies the Desktop PCs family of products from the default hierarchy of the products dimension.

       Source unitPCumTotal = unitPrice.cumulativeTotal(mdmTimeDefLvlHier, 0);
       Source measuresDim = dp.createListSource(new Source[] {unitPrice,
                                                              unitPCumTotal});

       Source result = measuresDim.extract()
                                  .join(measuresDim)
                                  .join(timeSel)
                                  .joinHidden(prodSel);

  A `Cursor` for `result` has the following values, which are displayed with headings for the products value `5`, (Desktop PCs), the time periods, the unit price, and the cumulative totals for the unit prices. The `Source` identifications (IDs) that are the values of the output of `result` for `measureDim`, which derive from joining `measuresDim` to the object returned by the `measureDim.extract()` method, do not appear in the display. Unit price values have had trailing zeros added.

       Product Family: Desktop PCs
       ---------------------------

            Time Period         Unit Price  Cumulative Total
       ---------------------    ----------  ----------------
       CALENDAR::YEAR::4        67116.90    287019.12
       CALENDAR::QUARTER::17    17036.98    236939.20
       CALENDAR::MONTH::55       5667.01    225569.23
       CALENDAR::MONTH::56       5671.97    231241.20
       CALENDAR::MONTH::57       5698.00    236939.20
       CALENDAR::QUARTER::18    16883.13    253822.33
       CALENDAR::QUARTER::67    16740.61    270562.94
       CALENDAR::QUARTER::68    16456.18    287019.12
       CALENDAR::YEAR::85      126868.90    413888.02
       CALENDAR::QUARTER::81    31664.34    318683.46
       CALENDAR::QUARTER::82    31933.96    350617.42
       CALENDAR::QUARTER::83    32003.64    382621.06
       CALENDAR::QUARTER::84    31266.96    413888.02

  The display of the values of `result` shows that, for each element of the `unitPrice` measure, the corresponding element of the `unitPCumTotal` measure has the total of the values of the `unitPrice` elements at the same level from the first element at that level to the current element.

  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative total. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the total of the values of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element.

### cumulativeTotal

    public final NumberSource cumulativeTotal(MdmLevelHierarchy dimension,
                                              int offset,
                                              MdmLevel resetLevel)

  For each element of this `NumberSource`, calculates the total of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative total calculation reset at the level specified by `resetLevel`. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative total. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
    `resetLevel` - The `MdmLevel` for the level of the `dimension` hierarchy at which you want the calculation of the cumulative totals to begin anew.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the total of the values of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element, and that has the cumulative total calculation reset at the specified level of the hierarchy.
  See Also:
    `cumulativeTotal(MdmLevelHierarchy dimension, int offset)`

### cumulativeAverage

    public final NumberSource cumulativeAverage(MdmLevelHierarchy dimension,
                                                int offset)

  For each element of this `NumberSource`, calculates the average of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative average. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the average of the values of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element.

### cumulativeAverage

    public final NumberSource cumulativeAverage(MdmLevelHierarchy dimension,
                                                int offset,
                                                MdmLevel resetLevel)

  For each element of this `NumberSource`, calculates the average of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative average calculation reset at the level specified by `resetLevel`. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative average. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
    `resetLevel` - The `MdmLevel` for the level of the `dimension` hierarchy at which you want the calculation of the cumulative average to begin anew.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the average of the values of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element, and that has the cumulative average calculation reset at the specified level of the hierarchy.

### cumulativeMaximum

    public final NumberSource cumulativeMaximum(MdmLevelHierarchy dimension,
                                                int offset)

  For each element of this `NumberSource`, calculates the maximum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative maximum. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the maximum value of this `NumberSource` of the values that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element.

### cumulativeMaximum

    public final NumberSource cumulativeMaximum(MdmLevelHierarchy dimension,
                                                int offset,
                                                MdmLevel resetLevel)

  For each element of this `NumberSource`, calculates the maximum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative maximum calculation reset at the level specified by `resetLevel`. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative maximum. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
    `resetLevel` - The `MdmLevel` for the level of the `dimension` hierarchy at which you want the calculation of the cumulative maximum to begin anew.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the maximum value of this `NumberSource` of the values that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element, and that has the cumulative maximum calculation reset at the specified level of the hierarchy.

### cumulativeMinimum

    public final NumberSource cumulativeMinimum(MdmLevelHierarchy dimension,
                                                int offset)

  For each element of this `NumberSource`, calculates the minimum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative minimum. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the minimum value of this `NumberSource` of the values that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element.

### cumulativeMinimum

    public final NumberSource cumulativeMinimum(MdmLevelHierarchy dimension,
                                                int offset,
                                                MdmLevel resetLevel)

  For each element of this `NumberSource`, calculates the minimum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the first element of `dimension` to the current element of `dimension` plus the number of elements specified by `offset`, with the cumulative minimum calculation reset at the level specified by `resetLevel`. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offset` - The number of elements of `dimension` relative to the current element of `dimension` to include in specifying the elements of this `NumberSource` for which values you want the cumulative minimum. An `offset` value of `0` (zero) includes the current value. An `offset` value of `-1` includes all of the values that precede the current value but does not include the current value.
    `resetLevel` - The `MdmLevel` for the level of the `dimension` hierarchy at which you want the calculation of the cumulative minimum to begin anew.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the minimum value of this `NumberSource` of the values that are specified by the values of the elements of `dimension` that are at the same level from the first element of dimension up to the element that is the `offset` number of elements away from the current element, and that has the cumulative minimum calculation reset at the specified level of the hierarchy.

### movingTotal

    public final NumberSource movingTotal(MdmLevelHierarchy dimension,
                                          int startOffset,
                                          int endOffset)

  For each element of this `NumberSource`, calculates the total of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`. A negative offset value specifies a value before the current value, a `0` (zero) value specifies the current value, and a positive value specifies a value after the current value. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `startOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the beginning of the elements to include in the specification of the elements of this `NumberSource` the values of which you want to total.
    `endOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the end of the elements to include in the specification of the elements of this `NumberSource` the values of which you want to total.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the total of the values of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the `startOffset` element of dimension up to the `endOffset` element.

### movingAverage

    public final NumberSource movingAverage(MdmLevelHierarchy dimension,
                                            int startOffset,
                                            int endOffset)

  For each element of this `NumberSource`, calculates the average of the values of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`. A negative offset value specifies a value before the current value, a `0` (zero) value specifies the current value, and a positive value specifies a value after the current value. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `startOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the beginning of the elements to include in the specification of the elements of this `NumberSource` the values of which you want to average.
    `endOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the end of the elements to include in the specification of the elements of this `NumberSource` the values of which you want to average.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the average of the values of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the `startOffset` element of dimension up to the `endOffset` element.

### movingMaximum

    public final NumberSource movingMaximum(MdmLevelHierarchy dimension,
                                            int startOffset,
                                            int endOffset)

  For each element of this `NumberSource`, determines the maximum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`. A negative offset value specifies a value before the current value, a `0` (zero) value specifies the current value, and a positive value specifies a value after the current value. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `startOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the beginning of the elements of this `NumberSource` to search for the maximum value.
    `endOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the end of the elements of this `NumberSource` to search for the maximum value.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the maximum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the `startOffset` element of dimension up to the `endOffset` element.

### movingMinimum

    public final NumberSource movingMinimum(MdmLevelHierarchy dimension,
                                            int startOffset,
                                            int endOffset)

  For each element of this `NumberSource`, determines the minimum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level of the hierarchy from the element of `dimension` specified by `startOffset` to the element specified by `endOffset`. A negative offset value specifies a value before the current value, a `0` (zero) value specifies the current value, and a positive value specifies a value after the current value. Call this method only on a `NumberSource` for an `MdmMeasure`.
  Parameters:
    `dimension` - An `MdmLevelHierarchy` that is a component of an `MdmPrimaryDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `startOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the beginning of the elements of this `NumberSource` to search for the minimum value.
    `endOffset` - The number of elements of `dimension` relative to the current element of `dimension` that marks the end of the elements of this `NumberSource` to search for the minimum value.
  Returns:
    A `NumberSource` that has, for each element of this `NumberSource`, the minimum value of the elements of this `NumberSource` that are specified by the values of the elements of `dimension` that are at the same level from the `startOffset` element of dimension up to the `endOffset` element.

### median

    public final NumberSource median()

  Calculates the median values of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` that has an element whose value is sum of the values of the elements of this `NumberSource`.

### variance

    public final NumberSource variance()

  Calculates the variance of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose element values are the variance of the values of the elements of this `NumberSource`.

### variancePop

    public final NumberSource variancePop()

  Calculates the population variance of the elements of this `NumberSource`. This method ignores elements with null values.
  Returns:
    A `NumberSource` whose element values are the population variance of the values of the elements of this `NumberSource`.

### varianceSamp

    public final NumberSource varianceSamp()

  Calculates the sample variance of the elements of this `NumberSource`.
  Returns:
    A `NumberSource` whose element values are the sample variance of the values of the elements of this `NumberSource`.

### stdevPop

    public final NumberSource stdevPop()

  Calculates the population standard deviation of the values of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that are the square roots of the population variances of the values of the elements of this `NumberSource`.

### stdevSamp

    public final NumberSource stdevSamp()

  Calculates the cumulative sample standard deviation of the values of this `NumberSource`.
  Returns:
    A `NumberSource` whose elements have values that are the square roots of the sample variances of the values of the elements of this `NumberSource`.

### positionalPeriodsAgo

    public final NumberSource positionalPeriodsAgo(MdmLevelHierarchy hierarchy,
                                                   MdmLevel offsetLevel,
                                                   int offset)

  A utility function to compute hierarchy-based lead/lag. Whereas other versions of lead/lag assume that the time hierarchy is based on a Gregorian calendar this function does not. Given a time value t on level l, the function will determine another time value t_periodsAgo as follows. 1. Determine the ancestor t_ancersor of t at the offsetLevel 2. Determine the position p of t among the elements of level l, which are the descendants of t_ancestor, where the dimension is sorted in the natural hierachical order. 3. Determine the target_ancesor by finding an element of the offsetLevel which is offset positions before (to the left of) t_ancestor (if offset is negative, than the target is found after (to the right of) t_ancestor. 4. Identifies the set s of ancestors of target_ancestor at level l, in sorted order. 5. If the number of elements in set s exceeds p, than t_periodsAgo is the last element of set s. 6. Otherwise t_periodsAgo is the element of s at position p. Examples. Let TIME be a dimension with levels year, month, day. Example 1: 1-month-ago (offset level: month, offset: 1) For Mar-31, this function will return Feb-28 because there is no 31st day in the month of Feb. Example 2: 1-year-ahead (offset level: year, offset: -1) For Feb-29-04 the function will return Mar-1-05 because Feb-29 is the 60th day of 2004 and Mar-1 is the 60th day of 2005.
  Parameters:
    `hierarchy` - An `MdmLevelHierarchy` that is a component of an `MdmTimeDimension` that is an input dimension of the `MdmMeasure` that this `NumberSource` represents.
    `offsetLevel` - An `MdmLevel` that is a component of the hierarchy.
    `offset` - The number of positions to add to or subtract from the position of each of the elements of the level.
  Returns:
    A `NumberSource` that has the elements of this `NumberSource` that are specified by the members of the level that are at the specified positions.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle® OLAP Java API Reference 10g Release 2 (10.2) B14348-02
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002, 2005, Oracle. All rights reserved.